-- # wBx(M de PINK)̗G

-- ## ƃfBNgύX
setCurrentDirectory(1)

-- ## ݒ̓ǂݍ
-- init@C̓ǂݍ
local parseIni = function (file, defaultSection)
    section = defaultSection or ""
    local ini = {}
    local reg_getSection = "^%[([^]]*)%]"
    local reg_getParameter = "([^%s]+)%s*=%s*(.-)%s*$"
    local reg_delComment = "%s*;.*$"
    local firstChr
    local parameterFlg
    for line in io.lines(file) do
        if line:len() ~= 0 then -- sȊO
            firstChr = line:sub(0, 1)
            if firstChr ~= "#" and firstChr ~= ";" then -- RgsȊO
                -- ## section
                section = line:match(reg_getSection) or ""
                ini[section] = ini[section] or {}

                -- ## parameter
                if section == "" then
                    for k, v in line:gmatch(reg_getParameter) do
                        v = v:gsub(reg_delComment, "")
                        ini[section or ""][k] = v
                    end
                end
            end
        end
    end
    return ini
end
-- ݒl擾
local setting = parseIni("tsukue.ini")
setting = setting[""]
local s_outputDir = setting["txtOutputDir"]
local s_inputDir = setting["txtImageDir"]
local s_lenInputDir = s_inputDir:len() + 1
local s_extension = "." .. setting["selType"]
local s_extensionNum = (s_extension == ".bmp") and 0 or 1
local s_isTrim = setting["chTrim"] or 0
local s_compressLevel = tonumber(setting["selCompressLevel"])


-- ## 萔
-- 摜
local BLEND_ALPHA = 1
-- Ώۃt@C̍i
local TARGET_TEXT = ".bmp"
-- t@C؂ׂ̕ʒu
local TXTFILE_NAME_POS_R = -11
local STAND_TYPE_E_POS = 4  -- G̃|[Ylx̕
local STAND_GROUP_E_POS = 6 -- G̕x̕
local FACE_GROUP_S_POS = 10
local FACE_GROUP_E_POS = 11
local EXTENSION_E_POS_R = -5
-- 摜̊{TCY
local BASE_IMAGE_SIZE = 256


-- ## ֐
-- ǂݍł摜t@CAo͂
local saveFile = function (facePos, maxY, file)
    local fileNum = "00"
    local nowGroup = ""
    local subPath = file:sub(s_lenInputDir, TXTFILE_NAME_POS_R)
    local path = ""
    copyImage(0, 1)
    for group, onefacePos in pairs(facePos) do
        if group ~= nowGroup then
            if s_isTrim == "1" then
                trimmingImage(0, "UDLR")
            end
            path = s_outputDir .. subPath .. fileNum .. s_extension
            saveImage(0, path, s_extensionNum, 0, s_compressLevel)
            fileNum = group:sub(FACE_GROUP_S_POS, FACE_GROUP_E_POS)
            nowGroup = group
            copyImage(0, 1)
            print("output: " .. path .. "\n")
        end
        for x, yTable in pairs(onefacePos) do
            for y, num in pairs(yTable) do
                blendImage(0, num, 1, x * BASE_IMAGE_SIZE, (maxY - y) * BASE_IMAGE_SIZE)
            end
        end
    end
    path = s_outputDir .. subPath .. fileNum .. s_extension
    if s_isTrim == "1" then
        trimmingImage(0, "UDLR")
    end
    saveImage(0, path, s_extensionNum, 0, s_compressLevel)
    print("output: " .. path .. "\n")
end


-- ## 
-- ϐ
local filePath, baseName
local thisStandType, nowStandType = "", ""
local thisStandGroup, nowStandGroup = "", ""
local faceGroup = ""
local newStandFlg, newTypeFlg = false
local imageNum, baseNum, faceNum = 0, 10, 100
local posXStart, posYStart
local posX, posY, numPosX, numPosY
local maxX, maxY = 0, 0
local sizeX, sizeY
local standPos, facePos = {}, {}
local subPath, path

-- `t@Cǂݍ݁A摜
local list = getFileList(s_inputDir, "*.txt", 1)
for i, file in pairs(list) do
    baseName = getBaseName(file)
    if baseName:sub(-4) == TARGET_TEXT then
        -- VKGׂ̈̏
        thisStandType = baseName:sub(0, STAND_TYPE_E_POS)
        newStandFlg = thisStandType ~= nowStandType
        if newStandFlg then
            nowStandType = thisStandType
        end
        -- 摜̏o͂я
        faceGroup = baseName:sub(0, FACE_GROUP_E_POS)
        thisStandGroup = baseName:sub(0, STAND_GROUP_E_POS)
        newTypeFlg = thisStandGroup ~= nowStandGroup -- x[XƂȂ摜VȂ邩ۂ
        if newTypeFlg then
            -- \e[uꍇ̏(񃋁[v͔΂)
            if next(facePos) then
                saveFile(facePos, maxY, filePath)
                freeImage(0)
                -- Ĝ̂ςꍇA\
                if newStandFlg then
                    facePos = {}
                    for num = 100, faceNum do
                        freeImage(num)
                    end
                end
            end
            nowStandGroup = thisStandGroup
            for num = 10, baseNum do
                freeImage(num)
            end
            -- 摜ԍ
            imageNum = 0   -- 摜ԍ0pA1x[X̕ێp
            baseNum  = 10  -- G10̘A
            faceNum  = 100 -- \100̘A
            -- W{
            maxX, maxY = 0, 0
            -- GW
            standPos = {}
        end
        -- `t@C̓ǂݍ
        subPath = getParentFolderName(file:sub(s_lenInputDir))
        for line in io.lines(file) do
            posYStart = line:find("@")
            posXStart = line:find(",")
            if posYStart then
                posX = line:sub(posXStart + 1, EXTENSION_E_POS_R)
                posY = line:sub(posYStart + 1, posXStart - 1)
                -- G
                if newTypeFlg then
                    standPos[posX] = standPos[posX] or {}
                    standPos[posX][posY] = baseNum
                    imageNum = baseNum
                    baseNum = baseNum + 1
                    numPosX, numPosY = tonumber(posX), tonumber(posY)
                    maxX = (maxX < numPosX) and numPosX or maxX
                    maxY = (maxY < numPosY) and numPosY or maxY
                -- \
                else
                    facePos[faceGroup] = facePos[faceGroup] or {}
                    facePos[faceGroup][posX] = facePos[faceGroup][posX] or {}
                    facePos[faceGroup][posX][posY] = faceNum
                    imageNum = faceNum
                    faceNum = faceNum + 1
                end
                -- 摜̓ǂݍ
                path = s_inputDir .. subPath .. line
                if existFile(path) == 0 then
                    path = path:gsub(".bmp$", ".png")
                end
                loadImage(imageNum, path)
            end
        end
        -- G̍
        if newTypeFlg then
            sizeX, sizeY = (maxX + 1) * BASE_IMAGE_SIZE, (maxY + 1) * BASE_IMAGE_SIZE
            createImage(1, sizeX, sizeY, 0x000000ff)
            for x, yTable in pairs(standPos) do
                for y, num in pairs(yTable) do
                    blendImage(1, num, 1, x * BASE_IMAGE_SIZE, (maxY - y) * BASE_IMAGE_SIZE)
                end
            end
            filePath = file
        end
    end
end

if next(facePos) then
    saveFile(facePos, maxY, filePath)
end
